#!/usr/bin/python
# -*- encoding:UTF-8 -*-

'''
-- PyDebug
-- Messiah93
-- http://messiah93.com
'''

import es
import sys
import time
import repeat
import traceback

def load ():
    Script.execConfig()
    hookExceptHook()
    Script.msg("Script\x03 chargé\x01.")
    Script.log("Loaded.")

def unload ():
    resetExternalExceptHook()
    Script.msg("Script\x03 stoppé\x01.")
    Script.log("Unloaded.")

class Script (object):
    def __init__ (self):
        self._loadImports("es", "os", "time", "usermsg", "unicodedata")
        
        self.info = es.AddonInfo()
        self.info.name = "PyDebug"
        self.info.version = "v0.03"
        self.info.author = "Messiah93"
        self.info.url = "http://messiah93.com"
        
        self.messiah93 = es.ServerVar("messiah93_%s" % self._getNormalizedString(self.info.name).lower().replace(" ", "_"))
        self.messiah93.set(self.info.version)
        self.messiah93.makepublic()
        
        self.file = os.path.basename(__file__).split(".")[0]
        self.here = es.getAddonPath(self.file) + os.sep
        self.base = es.getString("eventscripts_gamedir") + os.sep
        
        self.selfModule = __import__(self.file)
        
        self.configFile = "../addons/eventscripts/%s/%s_config.cfg" % (self.file, self.file)
    
    def execConfig (self):
        if self.configFile and os.path.exists(self.base + self.configFile.replace("../", "")):
            es.mexec(self.configFile)
    
    def printScriptInfos (self, userid):
        usermsg.echo(userid, "=================================\n—» %s - %s\n—» Messiah93 (www.messiah93.com)\n=================================" % (self.info.name, self.info.version))
    
    def msg (self, arg):
        es.msg("\x04[" + self.info.name + "]\x01 %s" % arg)
    
    def tell (self, userid, arg):
        es.tell(userid, "\x04[" + self.info.name + "]\x01 %s" % arg)
    
    def log (self, arg):
        name = self._getNormalizedString(self.info.name)
        arg = self._getNormalizedString(arg)
        
        es.log("[ES::" + name + "] %s" % arg)
    
    def logFile (self, arg):
        name = self._getNormalizedString(self.info.name)
        
        nowTime = time.strftime("[%d/%m/%Y %H:%M:%S]")
        
        self.log(arg)
        
        sef = open(self.here + "%s.log" % self.file, "a")
        sef.write(nowTime)
        sef.write("\n\t" + arg + "\n\n")
        sef.close()
    
    def echo (self, arg, level=0):
        name = self._getNormalizedString(self.info.name)
        arg = self._getNormalizedString(arg)
        
        es.dbgmsg(level, "[ES::" + name + "] %s" % arg)
    
    def _getNormalizedString (self, arg):
        try:
            arg = arg.decode("utf-8")
        except Exception:
            try:
                arg = unicode(arg, "raw-unicode-escape")
            except Exception:
                pass
        
        try:
            normalizedString = unicodedata.normalize("NFKD", arg)
            normalizedString = normalizedString.encode("ASCII", "ignore")
        except Exception: 
            normalizedString = arg
        
        return normalizedString
    
    def _loadImports (self, *imports):
        for lib in imports:
            if lib not in globals():
                globals()[lib] = __import__(lib)

Script = Script()

def player_activate (event_var):
    if sys.excepthook != internalExceptHook:
        Script.logFile("ERROR: 'sys.excepthook' has been changed. PyDebug no longer working.")

def internalExceptHook (exc_type, exc_value, exc_traceback):
    logFile = Script.base + "addons/eventscripts/python_errors.log"
    
    errorLog = traceback.format_exception(exc_type, exc_value, exc_traceback)
    nowTime = time.strftime("[%d/%m/%Y %H:%M:%S]")
    sep = ""
    
    for message in errorLog:
        es.dbgmsg(0, message.strip())
    
    while len(sep) != len(nowTime):
        sep = "".join(sep + "=")
    
    pef = None
    try:
        if not os.path.exists(logFile):
            pef = open(logFile, "w ")
        else:
            pef = open(logFile, "a")
        pef.writelines([nowTime] + ["\n" + sep + "\n"] + errorLog + [sep + "\n\n"])
    except Exception, error:
        Script.logFile("ERROR: %s" % error)
    finally:
        if pef:
            pef.close()

def hookExceptHook ():
    sys.excepthook = internalExceptHook

def resetExternalExceptHook ():
    sys.excepthook = sys.__excepthook__
